package cn.ninegame.genericframework.module;

import android.content.Context;

import cn.ninegame.genericframework.basic.Environment;

/**
 * Module生命周期管理对象
 * Created by lingcong on 2016/4/7.
 */
public class ModuleApplication implements IModuleComponent {

    private IModuleEntry mModuleEntry;
    private Environment mEnv;

    public void onCreate() {
    }

    public void onDestroy() {
    }

    @Override
    public void setModuleEntry(IModuleEntry entry) {
        mModuleEntry = entry;
    }

    @Override
    public Context getContext() {
        checkModuleEntry();
        return mModuleEntry.getContext();
    }

    @Override
    public void setEnvironment(Environment environment) {
        mEnv = environment;
    }

    @Override
    public Environment getEnvironment() {
        return mEnv;
    }

    @Override
    public String getModuleRootPath() {
        checkModuleEntry();

        return mModuleEntry.getModuleRootPath();
    }

    @Override
    public String getModuleDataPath() {
        checkModuleEntry();

        return mModuleEntry.getModuleDataPath();
    }

    @Override
    public String getModuleSoPath() {
        checkModuleEntry();

        return mModuleEntry.getModuleSoPath();
    }

    public String getModuleID () {
        checkModuleEntry();

        return  mModuleEntry.getModuleInfo().getID();
    }

    private void checkModuleEntry() {
        if (mModuleEntry == null) {
            throw new RuntimeException(String.format("mModuleEntry is null, className = %s", getClass().getName()));
        }
    }
}
